#include <EEPROM.h>



int rul = 3; //PPM in for INT1
int gaz = 2; //PPM in for INT2
int gabar_stop1 = 16;            // фара стоп 1
int gabar_stop2 = 18;            // фара стоп 2


int left1 = 14;                  //левый поворотник
int right1 = 15;                 //правый поворотник 

int zadni = 17;                  //задний ход

int cab = 10 ;                   // кнопка калибровки


#define EE_HOD 4
#define EE_POV 6




volatile unsigned long lt, ct, ms_rul,tmp, lt1, ct1, ms_gaz,tmp1, maxgaz, mingaz, maxrul, minrul,mig,far ;

volatile  unsigned long zad, zad1 ;

int ms_pov;
int ms_xod;

void EEPROMWriteInt(int p_address, int p_value)
        {
        byte lowByte = ((p_value >> 0) & 0xFF);
        byte highByte = ((p_value >> 8) & 0xFF);
         EEPROM.write(p_address , lowByte);
         EEPROM.write(p_address + 1, highByte);
        }
unsigned int EEPROMReadInt(int p_address)
        {
        byte lowByte = EEPROM.read(p_address);
        byte highByte = EEPROM.read(p_address + 1);

        return ((lowByte << 0) & 0xFF) + ((highByte << 8) & 0xFF00);
        }
        
        char tim;
        int tim1; 
        
void setup(){
  ms_xod=EEPROMReadInt (EE_HOD);
  ms_pov=EEPROMReadInt (EE_POV);
  if (ms_xod<100) ms_xod=1500;              // тримирование газа
  if (ms_pov<100) ms_pov=1500;              // тримирование поворотников


  tim=0;
  tim1=0;
  

  digitalWrite (cab, HIGH);

  pinMode (cab, INPUT);
  
  
  
  pinMode(rul, INPUT);
  pinMode(gaz, INPUT);
  
  pinMode (gabar_stop1, OUTPUT);
  pinMode (gabar_stop2, OUTPUT);
  
  pinMode (left1, OUTPUT);
  pinMode (right1, OUTPUT);
    
  pinMode (zadni, OUTPUT); 
  
 
  
  digitalWrite (gabar_stop1, LOW);
  digitalWrite (gabar_stop2, LOW);
  
  digitalWrite (zadni, LOW);

  
  digitalWrite (left1, LOW);
  digitalWrite (right1, LOW);

  
  digitalWrite (rul, HIGH);                  //Pull-up pin
  digitalWrite (gaz, HIGH);                  //Pull-up pin


  attachInterrupt(0, rul_ppm, CHANGE);       //PPM read interrupt
  attachInterrupt(1, gaz_ppm, CHANGE);       //PPM read interrupt
  
  Serial.begin(9600);

    
}


void gaz_ppm() {                       // PPM read interrupt
 ct = micros();                        // read current time
 ms_gaz=ct-lt;                         // ms = current time - last time
 lt=ct;                                // last time
 if(ms_gaz>2200)  ms_gaz=tmp;          // fix time bug
 tmp=ms_gaz;                           // fix time bug
}    
void rul_ppm() {                       // PPM read interrupt
 ct1 = micros();                       // read current time
 ms_rul=ct1-lt1;                       // ms = current time - last time
 lt1=ct1;                              // last time
 if(ms_rul>2200)  ms_rul=tmp1;         // fix time bug
 tmp1=ms_rul;                          // fix time bug
}

 char st;
 char ms;
 




#define MS_RIL_MAX ms_pov+100                    // чуствительность руля в строчку ms_pov+100 в место 100 значение от 10 (высока чуствительность) до 400(низкаячуствительность)
#define MS_RIL_MIN ms_pov-100                    // чуствительность руля в строчку ms_pov-100 в место 100 значение от 10 (высока чуствительность) до 400(низкаячуствительность)


#define MS_GAZ_MIN ms_xod-100                    // чуствительность газа в строчку ms_xod-100 в место 100 значение от 10 (высока чуствительность) до 400(низкаячуствительность)
#define MS_GAZ_MAX ms_xod+100                    // чуствительность газа в строчку ms_xod+100 в место 100 значение от 10 (высока чуствительность) до 400(низкаячуствительность)


#define MS_STOIT 0
#define MS_FORWARD 1
#define MS_ZAD 2 
#define MS_TORMAZ 3
#define KYROC_HS ms_gaz>MS_GAZ_MAX
#define KYROC_OS ms_gaz<MS_GAZ_MIN
#define KYROC_OO (ms_gaz<MS_GAZ_MAX) && (ms_gaz>MS_GAZ_MIN)

void loop()
{

  if (digitalRead(cab)==0){
    ms_xod=ms_gaz;
    ms_pov=ms_rul;
    EEPROMWriteInt(EE_HOD,ms_xod);
    EEPROMWriteInt(EE_POV,ms_pov);
  }
  
  st++;
  if (st>=10) st=0;                       // скорость мигания поворотников в строчку st>=10 вместо 10 от 7 (высокая скорость) до 50(низкая скорость)

  tim1++;
  if (tim1>2000) tim1=2000;


  switch(ms){                             // 1 вариант
   case MS_STOIT:
    if(KYROC_HS) ms=MS_FORWARD;
    if(KYROC_OS) {
       if (tim==0) ms=MS_ZAD; else         ms=MS_TORMAZ;
    }
    break;
   case MS_FORWARD:
    if(KYROC_OO) {ms=MS_STOIT;tim=10;tim1=0;}
    if(KYROC_OS) ms=MS_TORMAZ;
    break;
   case MS_ZAD:
    if(KYROC_HS) ms=MS_FORWARD;
    if(KYROC_OO) {ms=MS_STOIT;tim1=0;}
    break;
    case MS_TORMAZ:
    if(KYROC_OO) {ms=MS_STOIT;tim1=0;}
    if(KYROC_HS) ms=MS_FORWARD;
    break; 
    default:
    ms=MS_STOIT;tim1=0; 
  }                                       // 1 вариант
  
  if (tim) tim--;
  

  if ((tim1>200)&&(ms==MS_STOIT)) {                          //время запуска аварийки (tim1>1555) чило 1555(может быть любым) умножаем на 50 и делим на 100 и получаем время через сколько включится аварийка в секундах
  digitalWrite(left1,(st>5));                                 // скорость мигания одельно левого поворотников в режиме аварийки
  digitalWrite(right1,(st>5));                                // скорость мигания одельно правого поворотников в режиме аварийки
  } else{
  digitalWrite(left1,(st>5)&&(ms_rul<MS_RIL_MIN));            // скорость мигания одельно левого поворотников
  digitalWrite(right1,(st>5)&&(ms_rul>MS_RIL_MAX));           // скорость мигания одельно правого поворотников
  }
  
  digitalWrite(zadni,ms==MS_ZAD); 
  digitalWrite(gabar_stop1,ms==MS_TORMAZ);
   if (ms==MS_STOIT) {
    digitalWrite(gabar_stop1,1);
  }
  digitalWrite(gabar_stop2,ms==MS_TORMAZ);                    
  
  
  
  //digitalWrite(gabar_stop2,(ms_gaz<MS_GAZ_MIN));            // 2 вариант
  //digitalWrite(gabar_stop1,(ms_gaz>MS_GAZ_MAX));            // 2 вариант
  



   
 
  Serial.print(ms_xod);
  Serial.print("   ");
  Serial.print(ms_gaz); // ms = PPM ms
  Serial.print("   "); // ms = PPM ms
  Serial.print(ms_pov); // ms = PPM ms
  Serial.print("   "); // ms = PPM ms
  Serial.println(ms_rul);



  
  
  delay(50);
  }
  

